

getwd()
setwd("/Users/Carly/Documents/LipsLab/Gabe_project/Final_plate_reads/")

Bd <- read.csv("final_all_plates_gabe_no_contam.csv")

Bd$T_OD <- NA


# For each plate
# For each row in the isol df 
for(i in 1:nrow(Bd)){
  
  # Take the OD of the row i and divide by the AveND -1 and assign it to Inhibit column in isol df
  Bd$T_OD[i] <-  log((Bd$OD[i] / (1-Bd$OD[i])+1)) 
   
}


hist(Bd$OD)
## This transformation makes the data more linear, better to fit 
## linear models to 
hist(Bd$T_OD)

## We want to calculate the slope of growth for each well in our assays

## We want to take an average of those slopes for each bacteria 
## or controls

# Then we want to divide the average slope of each sample-Bd combo by the 
# nutrient-depleted positive control for the specific Bd isolate
# and then substract one and we get our inhibition score!!!!!!

## First let's merge column and row to make a well column

Well <- as.factor(paste(Bd$Row, Bd$Column, sep = ""))
Bd <- cbind(Bd,Well)

## Make a column to put in calculated slopes
Bd$Inhibit_slope <- NA

## specify unique plates
plate_unique <- unique(Bd$Plate)

## specify our intercept as 0
intercept = 0  

# For each plate
for(i in 1:length(plate_unique)){
  
  Plate_subset <- subset(Bd, Plate == plate_unique[i]) 
  
  iso <- unique(Plate_subset$Isolate)
  
  # For each of unique isolates 
  for(j in 1:length(iso)){
    
    # Subset to only that iso i and assign it to a new dataframe isol
    isol <- subset(Plate_subset, Isolate==iso[j])
    
    well <- unique(isol$Well)
    
      # For each unique well
      for(k in 1:length(well)){
  
        # Subset to that well and assign it to a new dataframe well_subset
        well_subset <- subset(isol, Well == well[k])
    
      # Make a linear model for each bacteria based on the transformed OD
  
    lm_well <- lm(I(well_subset$T_OD - intercept) ~ 0 + well_subset$Day)
   
    ## then take the slope and put into appropriate column in isol df
    ## if we didn't force the intercept slope is in [2]
    ## well_subset$Inhibit_slope <- lm_well$coefficients[2]
  
    well_subset$Inhibit_slope <- lm_well$coefficients[1]
   well_subset$R_squared <- summary(lm_well)$adj.r.squared
   well_subset$R_squared <- ifelse(well_subset$R_squared < 0.2, NA, well_subset$R_squared) 
   well_subset$Inhibit_slope <- ifelse(well_subset$R_squared < 0.2, NA, well_subset$Inhibit_slope) 
    
    # Once that is all completed for that unique isolate, assign it into the original df 
    isol[isol$Well==well[k],"Inhibit_slope"] <- well_subset$Inhibit_slope
   isol[isol$Well==well[k],"R_squared"] <- well_subset$R_squared
   
    
    ## get the average of ND inhibit_slope
    aveND <- mean(isol$Inhibit_slope[isol$Bacteria == "ND"])
    
    ## for each row in the isol df
    for(l in 1:nrow(isol)){
      
      # Take the inhibit_Slope of the row l and divide by the Avg ND slope and then -1, 
      # Assign to new column called final_inhibition
      isol$final_inhibition[l] <- 1- (isol$Inhibit_slope[l]/aveND)
    }
    
  }
  
  # Once that is all completed for that unique isolate, assign it into the original df 
  Plate_subset[Plate_subset$Isolate==iso[j],"Inhibit_slope"] <- isol$Inhibit_slope
  Plate_subset[Plate_subset$Isolate==iso[j],"final_inhibition"] <- isol$final_inhibition
  Plate_subset[Plate_subset$Isolate==iso[j],"R_squared"] <- isol$R_squared
  
  
}
  
  Bd[Bd$Plate==plate_unique[i],"Inhibit_slope"] <- Plate_subset$Inhibit_slope
  Bd[Bd$Plate==plate_unique[i],"final_inhibition"] <- Plate_subset$final_inhibition
Bd[Bd$Plate==plate_unique[i],"R_squared"] <- Plate_subset$R_squared
}

## we have replication of the final_inhibition for every day, need to subset only one day

Bd_scores <- Bd[Bd$Day == "1",]

Bd_scores_2 <- na.omit(Bd_scores)

Bd_scores_2$final_inhibition_percent <- Bd_scores_2$final_inhibition * 100

write.csv(Bd_scores_2, "Inhibition_scores_final.csv")



